﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class addCharityToTribute : System.Web.UI.Page
    {
        protected const string operation = "addCharityToTribute";

        protected string Data
        {
            get
            {
                return                                      "api_key="                  + HttpUtility.UrlEncode(txt_api_key.Text)                   +
                    (txt_user_id.Text               != "" ? "&user_id="                 + HttpUtility.UrlEncode(txt_user_id.Text)                   : "") +
                    (txt_tribute_id.Text            != "" ? "&tribute_id="              + HttpUtility.UrlEncode(txt_tribute_id.Text)                : "") +
                    (txt_charity_ids.Text           != "" ? "&charity_ids="             + HttpUtility.UrlEncode(txt_charity_ids.Text)               : "");
            }
        }

        protected string SOAPData
        {
            get
            {
                return                                      "<api_key>"                 + txt_api_key.Text                      + "</api_key>"                  +
                    (txt_user_id.Text               != "" ? "<user_id>"                 + txt_user_id.Text                      + "</user_id>"                  : "") +
                    (txt_tribute_id.Text            != "" ? "<tribute_id>"              + txt_tribute_id.Text                   + "</tribute_id>"               : "") +
                    (txt_charity_ids.Text           != "" ? "<charity_ids>"             + txt_charity_ids.Text                  + "</charity_ids>"              : "");
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text                        = ConfigurationManager.AppSettings["APIKey"].ToString();
            txt_user_id.Text                        = ConfigurationManager.AppSettings["UserID"].ToString();
            txt_tribute_id.Text                     = "";
            txt_charity_ids.Text                    = "";
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;

            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                id.Text                             = responseNode["Data"]["id"].InnerText;
                name.Text                           = responseNode["Data"]["name"].InnerText;
                
                if (responseNode["Data"]["tribute_group"]["tributes"] != null)
                {
                    tg_page_name.Text = responseNode["Data"]["tribute_group"]["page_name"].InnerText;

                    SubResultsRepeater.DataSource = responseNode["Data"]["tribute_group"]["tributes"].ChildNodes;
                    SubResultsRepeater.DataBind();
                }
                ResultPanel.Visible                 = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }

        protected void BindSubResults(Object sender, RepeaterItemEventArgs e)
        {
            XmlNode xmlNode                     = (XmlNode)e.Item.DataItem;

            Literal id                          = (Literal)e.Item.FindControl("id");
            Literal page_name                   = (Literal)e.Item.FindControl("page_name");
            Literal name                        = (Literal)e.Item.FindControl("name");

            Literal charity_id                  = (Literal)e.Item.FindControl("charity_id");
            Literal charity_name                = (Literal)e.Item.FindControl("charity_name");
            
            id.Text                             = xmlNode["id"].InnerText;
            page_name.Text                      = xmlNode["page_name"].InnerText;
            name.Text                           = xmlNode["name"].InnerText;

            charity_id.Text                     = xmlNode["charity_id"].InnerText;
        }
    }
}