﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class searchCharities : System.Web.UI.Page
    {
        protected const string operation = "searchCharities";

        protected string Data
        {
            get
            {
                return                                  "api_key="          + HttpUtility.UrlEncode(txt_api_key.Text)       +
                        (txt_charity_name.Text  != "" ? "&charity_name="    + HttpUtility.UrlEncode(txt_charity_name.Text)  : "");
            }
        }

        protected string SOAPData
        {
            get
            {
                return                                  "<api_key>"         + txt_api_key.Text      + "</api_key>"      +
                        (txt_charity_name.Text  != "" ? "<charity_name>"    + txt_charity_name.Text + "</charity_name>" : "");
            }
        }
        
        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text        = ConfigurationManager.AppSettings["APIKey"].ToString();
            txt_charity_name.Text   = "";
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            
            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                search_results.DataSource   = responseNode.GetElementsByTagName("SearchResultItemCharity");
                search_results.DataBind();

                ResultPanel.Visible         = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }

        protected void BindSearchResults(Object sender, RepeaterItemEventArgs e)
        {
            XmlNode xmlNode                     = (XmlNode)e.Item.DataItem;

            Literal id                          = (Literal)e.Item.FindControl("id");
            Literal name                        = (Literal)e.Item.FindControl("name");
            Literal aliases                     = (Literal)e.Item.FindControl("aliases");
            Literal number                      = (Literal)e.Item.FindControl("number");
            Image image                         = (Image)e.Item.FindControl("image");

            id.Text             = xmlNode["ID"].InnerText;
            name.Text           = xmlNode["Name"].InnerText;
            aliases.Text        = xmlNode["Aliases"].InnerText;
            number.Text         = xmlNode["Number"].InnerText;
            image.ImageUrl      = "http://" + xmlNode["LogoPath"].InnerText;
        }
    }
}