﻿using System;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.UI.WebControls;

namespace Memory_Giving_API_Examples
{
    public partial class suggestCharity : System.Web.UI.Page
    {
        protected const string operation = "suggestCharity";

        protected string Data
        {
            get
            {
                return 
                                                        "api_key="          + HttpUtility.UrlEncode(txt_api_key.Text)           +
                    (txt_user_id.Text           != "" ? "&user_id="         + HttpUtility.UrlEncode(txt_user_id.Text)           : "") +
                    (txt_charity_name.Text      != "" ? "&charity_name="    + HttpUtility.UrlEncode(txt_charity_name.Text)      : "") +
                    (txt_charity_number.Text    != "" ? "&charity_number="  + HttpUtility.UrlEncode(txt_charity_number.Text)    : "");
                    
            }
        }

        protected string SOAPData
        {
            get
            {
                return 
                                                        "<api_key>"         + txt_api_key.Text          + "</api_key>"          +
                    (txt_user_id.Text           != "" ? "<user_id>"         + txt_user_id.Text          + "</user_id>"          : "") +
                    (txt_charity_name.Text      != "" ? "<charity_name>"    + txt_charity_name.Text     + "</charity_name>"     : "") +
                    (txt_charity_number.Text    != "" ? "<charity_number>"  + txt_charity_number.Text   + "</charity_number>"   : "");
                    
            }
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            txt_api_key.Text                        = ConfigurationManager.AppSettings["APIKey"].ToString();
            txt_user_id.Text                        = ConfigurationManager.AppSettings["UserID"].ToString();
            txt_charity_name.Text                   = "";
            txt_charity_number.Text                 = "";
        }

        protected void DoGet(Object sender, EventArgs e)
        {
            Response.Redirect(ConfigurationManager.AppSettings["Host"].ToString() + ConfigurationManager.AppSettings["WebService"].ToString() + "/" + operation + "?" + Data);
        }

        protected void DoPost(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            
            try
            {
                XmlDocument xmlResponse = HttpRequest.Execute(operation, Data);

                PopulateResponseData(xmlResponse.DocumentElement);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void DoSOAP(Object sender, EventArgs e)
        {
            ErrorPanel.Visible =
            ResultPanel.Visible = false;
            try
            {
                HttpRequest.SoapVersion ver = ((LinkButton)sender).ID == "lbtnSOAP11" ? HttpRequest.SoapVersion.SOAP : HttpRequest.SoapVersion.SOAP12;
                XmlDocument xmlResponse = HttpRequest.ExecuteSOAP(operation, SOAPData, ver);

                PopulateResponseData(xmlResponse.DocumentElement["soap:Body"][operation + "Response"][operation + "Result"]);
            }
            catch (Exception ex)
            {
                ErrorSeverity.Text = "";
                ErrorInternalMessage.Text = ex.Message;
                ErrorFriendlyMessage.Text = "";

                ErrorPanel.Visible = true;
            }
        }

        protected void PopulateResponseData(XmlElement responseNode)
        {
            if (responseNode["Error"] == null)
            {
                id.Text                     = responseNode["Data"]["id"].InnerText;
                charity_name.Text           = responseNode["Data"]["charity_name"].InnerText;
                charity_number.Text         = responseNode["Data"]["charity_number"].InnerText;

                ResultPanel.Visible         = true;
            }
            else
            {
                ErrorSeverity.Text          = responseNode["Error"]["Severity"].InnerText;
                ErrorInternalMessage.Text   = responseNode["Error"]["InternalMessage"].InnerText;
                ErrorFriendlyMessage.Text   = responseNode["Error"]["FriendlyMessage"].InnerText;

                ErrorPanel.Visible          = true;
            }
        }
    }
}